<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"  xmlns:fn="http://www.example.com/fn"
    version="3.0">
    
    
    <xsl:function name="fn:indent" as="text()">
        <xsl:param name="depth" as="xs:integer"/>
        <xsl:param name="indent-spaces" as="xs:integer"/>
        <xsl:value-of select="'abc', sum((1 to ($depth + 1) * $indent-spaces), 2)"/>
    </xsl:function>
    
    <xsl:template name="copy-properties-excluding-prefix">
        
        <xsl:param name="doc"/>
        <xsl:param name="page-name"/>
        <xsl:param name="margin-box-name"/>
        
        <xsl:param name="props" select="''"/>
        
        
        <!-- Put the matching pages in a sequence. The last page is the named one, and is more priority. -->
        <xsl:variable name="matching-pages" select="//page[not(@name) or @name = 'default'][not(@pseudo)],//page[@name = $page-name]"/>
        <xsl:variable name="matching-box-margins" select="$matching-pages//*[local-name() = $margin-box-name]"/>
        
        
        <xsl:variable name="et" select="tokenize($props, ', ')"/>
        
        <!-- For all the distinct property names from the matching margin boxes -->
        <xsl:for-each select="distinct-values($matching-box-margins//property/@name)">
            <xsl:variable name="cName" select="."/>
            
            <!-- Check if they are matching the prefix exclusion criteria -->
            <xsl:variable name="found">
                <xsl:for-each select="$et">
                    <xsl:if test="starts-with(., $cName)">true</xsl:if>
                </xsl:for-each>
            </xsl:variable>
            
            <!-- If they do, then the value of the last property having that name, if is the most important. -->
            <xsl:if test="string-length($found) = 0">
                <xsl:attribute name="{$cName}" select="$matching-box-margins//property[@name=$cName][position() = last()]/@value"/>
            </xsl:if>
            <xsl:if test="string-length($found) = 1">
                <!-- XSLT code -->
            </xsl:if>
        </xsl:for-each>
    </xsl:template>
   
</xsl:stylesheet>